/*
XOWA: the XOWA Offline Wiki Application
Copyright (C) 2012-2017 gnosygnu@gmail.com

XOWA is licensed under the terms of the General Public License (GPL) Version 3,
or alternatively under the terms of the Apache License Version 2.0.

You may use XOWA according to either of these licenses as is most appropriate
for your project on a case-by-case basis.

The terms of each license can be found in the source code repository:

GPLv3 License: https://github.com/gnosygnu/xowa/blob/master/LICENSE-GPLv3.txt
Apache License: https://github.com/gnosygnu/xowa/blob/master/LICENSE-APACHE2.txt
*/
package gplx.xowa.langs; import gplx.*; import gplx.xowa.*;
import gplx.core.lists.*;
public class Xol_lang_stub_ {	// lists all known stub_ary supported by MW
	public static final    byte[] Key__unknown = Bry_.Empty;
	public static final    ComparerAble Comparer_key = new Xol_sub_itm_comparer();
	public static final int 
  Id__intl = -2
, Id__unknown = -1
, Id_en = 0
, Id_aa = 1
, Id_ab = 2
, Id_ace = 3
, Id_ady = 4
, Id_ady_cyrl = 5
, Id_aeb = 6
, Id_aeb_arab = 7
, Id_aeb_latn = 8
, Id_af = 9
, Id_ak = 10
, Id_akz = 11
, Id_aln = 12
, Id_als = 13
, Id_am = 14
, Id_an = 15
, Id_ang = 16
, Id_anp = 17
, Id_ar = 18
, Id_arc = 19
, Id_arn = 20
, Id_aro = 21
, Id_arq = 22
, Id_ary = 23
, Id_arz = 24
, Id_as = 25
, Id_ase = 26
, Id_ast = 27
, Id_av = 28
, Id_avk = 29
, Id_awa = 30
, Id_ay = 31
, Id_az = 32
, Id_azb = 33
, Id_ba = 34
, Id_ban = 35
, Id_bar = 36
, Id_bat_smg = 37
, Id_bbc = 38
, Id_bbc_latn = 39
, Id_bcc = 40
, Id_bcl = 41
, Id_be = 42
, Id_be_tarask = 43
, Id_be_x_old = 44
, Id_bew = 45
, Id_bg = 46
, Id_bgn = 47
, Id_bh = 48
, Id_bho = 49
, Id_bi = 50
, Id_bjn = 51
, Id_bm = 52
, Id_bn = 53
, Id_bo = 54
, Id_bpy = 55
, Id_bqi = 56
, Id_br = 57
, Id_brh = 58
, Id_bs = 59
, Id_bto = 60
, Id_bug = 61
, Id_bxr = 62
, Id_ca = 63
, Id_cbk_zam = 64
, Id_cdo = 65
, Id_ce = 66
, Id_ceb = 67
, Id_ch = 68
, Id_chm = 69
, Id_cho = 70
, Id_chr = 71
, Id_chy = 72
, Id_ckb = 73
, Id_co = 74
, Id_cps = 75
, Id_cr = 76
, Id_crh = 77
, Id_crh_cyrl = 78
, Id_crh_latn = 79
, Id_cs = 80
, Id_csb = 81
, Id_cu = 82
, Id_cv = 83
, Id_cy = 84
, Id_da = 85
, Id_de = 86
, Id_de_at = 87
, Id_de_ch = 88
, Id_de_formal = 89
, Id_diq = 90
, Id_dsb = 91
, Id_dtp = 92
, Id_dty = 93
, Id_dv = 94
, Id_dz = 95
, Id_ee = 96
, Id_egl = 97
, Id_el = 98
, Id_eml = 99
, Id_en_ca = 100
, Id_en_gb = 101
, Id_en_rtl = 102
, Id_enrtl = 103
, Id_eo = 104
, Id_es = 105
, Id_es_formal = 106
, Id_esu = 107
, Id_et = 108
, Id_eu = 109
, Id_ext = 110
, Id_fa = 111
, Id_ff = 112
, Id_fi = 113
, Id_fit = 114
, Id_fiu_vro = 115
, Id_fj = 116
, Id_fo = 117
, Id_fr = 118
, Id_frc = 119
, Id_frp = 120
, Id_frr = 121
, Id_fur = 122
, Id_fy = 123
, Id_ga = 124
, Id_gag = 125
, Id_gan = 126
, Id_gan_hans = 127
, Id_gan_hant = 128
, Id_gd = 129
, Id_gl = 130
, Id_glk = 131
, Id_gn = 132
, Id_gom = 133
, Id_gom_deva = 134
, Id_gom_latn = 135
, Id_gor = 136
, Id_got = 137
, Id_grc = 138
, Id_gsw = 139
, Id_gu = 140
, Id_guc = 141
, Id_gv = 142
, Id_ha = 143
, Id_hak = 144
, Id_haw = 145
, Id_he = 146
, Id_hi = 147
, Id_hif = 148
, Id_hif_latn = 149
, Id_hil = 150
, Id_ho = 151
, Id_hr = 152
, Id_hrx = 153
, Id_hsb = 154
, Id_hsn = 155
, Id_ht = 156
, Id_hu = 157
, Id_hu_formal = 158
, Id_hy = 159
, Id_hz = 160
, Id_ia = 161
, Id_id = 162
, Id_ie = 163
, Id_ig = 164
, Id_ii = 165
, Id_ik = 166
, Id_ike_cans = 167
, Id_ike_latn = 168
, Id_ilo = 169
, Id_inh = 170
, Id_io = 171
, Id_is = 172
, Id_it = 173
, Id_iu = 174
, Id_izh = 175
, Id_ja = 176
, Id_jam = 177
, Id_jbo = 178
, Id_jut = 179
, Id_jv = 180
, Id_ka = 181
, Id_kaa = 182
, Id_kab = 183
, Id_kbd = 184
, Id_kbd_cyrl = 185
, Id_kg = 186
, Id_khw = 187
, Id_ki = 188
, Id_kiu = 189
, Id_kj = 190
, Id_kk = 191
, Id_kk_arab = 192
, Id_kk_cn = 193
, Id_kk_cyrl = 194
, Id_kk_kz = 195
, Id_kk_latn = 196
, Id_kk_tr = 197
, Id_kl = 198
, Id_km = 199
, Id_kn = 200
, Id_ko = 201
, Id_ko_kp = 202
, Id_koi = 203
, Id_kok = 204
, Id_kr = 205
, Id_krc = 206
, Id_kri = 207
, Id_krj = 208
, Id_krl = 209
, Id_ks = 210
, Id_ks_arab = 211
, Id_ks_deva = 212
, Id_ksh = 213
, Id_ku = 214
, Id_ku_arab = 215
, Id_ku_latn = 216
, Id_kv = 217
, Id_kw = 218
, Id_ky = 219
, Id_la = 220
, Id_lad = 221
, Id_lb = 222
, Id_lbe = 223
, Id_lez = 224
, Id_lfn = 225
, Id_lg = 226
, Id_li = 227
, Id_lij = 228
, Id_liv = 229
, Id_lki = 230
, Id_lmo = 231
, Id_ln = 232
, Id_lo = 233
, Id_loz = 234
, Id_lrc = 235
, Id_lt = 236
, Id_ltg = 237
, Id_lus = 238
, Id_luz = 239
, Id_lv = 240
, Id_lzh = 241
, Id_lzz = 242
, Id_mai = 243
, Id_map_bms = 244
, Id_mdf = 245
, Id_mg = 246
, Id_mh = 247
, Id_mhr = 248
, Id_mi = 249
, Id_mic = 250
, Id_min = 251
, Id_mk = 252
, Id_ml = 253
, Id_mn = 254
, Id_mnc = 255
, Id_mo = 256
, Id_mr = 257
, Id_mrj = 258
, Id_ms = 259
, Id_mt = 260
, Id_mui = 261
, Id_mus = 262
, Id_mwl = 263
, Id_mwv = 264
, Id_my = 265
, Id_myv = 266
, Id_mzn = 267
, Id_na = 268
, Id_nah = 269
, Id_nan = 270
, Id_nap = 271
, Id_nb = 272
, Id_nds = 273
, Id_nds_nl = 274
, Id_ne = 275
, Id_new = 276
, Id_ng = 277
, Id_niu = 278
, Id_nl = 279
, Id_nl_informal = 280
, Id_nn = 281
, Id_no = 282
, Id_nov = 283
, Id_nrm = 284
, Id_nso = 285
, Id_nv = 286
, Id_ny = 287
, Id_oc = 288
, Id_olo = 289
, Id_om = 290
, Id_or = 291
, Id_os = 292
, Id_pa = 293
, Id_pag = 294
, Id_pam = 295
, Id_pap = 296
, Id_pbb = 297
, Id_pcd = 298
, Id_pdc = 299
, Id_pdt = 300
, Id_pfl = 301
, Id_pi = 302
, Id_pih = 303
, Id_pl = 304
, Id_pms = 305
, Id_pnb = 306
, Id_pnt = 307
, Id_ppl = 308
, Id_prg = 309
, Id_ps = 310
, Id_pt = 311
, Id_pt_br = 312
, Id_qqq = 313
, Id_qu = 314
, Id_qug = 315
, Id_rap = 316
, Id_rgn = 317
, Id_rif = 318
, Id_rm = 319
, Id_rmf = 320
, Id_rmy = 321
, Id_rn = 322
, Id_ro = 323
, Id_roa_rup = 324
, Id_roa_tara = 325
, Id_ru = 326
, Id_rue = 327
, Id_rup = 328
, Id_ruq = 329
, Id_ruq_cyrl = 330
, Id_ruq_latn = 331
, Id_rw = 332
, Id_ryu = 333
, Id_sa = 334
, Id_sah = 335
, Id_sat = 336
, Id_saz = 337
, Id_sc = 338
, Id_scn = 339
, Id_sco = 340
, Id_sd = 341
, Id_sdc = 342
, Id_sdh = 343
, Id_se = 344
, Id_sei = 345
, Id_ses = 346
, Id_sg = 347
, Id_sgs = 348
, Id_sh = 349
, Id_shi = 350
, Id_shn = 351
, Id_si = 352
, Id_simple = 353
, Id_sk = 354
, Id_sl = 355
, Id_sli = 356
, Id_sly = 357
, Id_sm = 358
, Id_sma = 359
, Id_sn = 360
, Id_so = 361
, Id_sq = 362
, Id_sr = 363
, Id_sr_ec = 364
, Id_sr_el = 365
, Id_srn = 366
, Id_ss = 367
, Id_st = 368
, Id_stq = 369
, Id_su = 370
, Id_sv = 371
, Id_sw = 372
, Id_sxu = 373
, Id_szl = 374
, Id_ta = 375
, Id_tcy = 376
, Id_te = 377
, Id_test = 378
, Id_tet = 379
, Id_tg = 380
, Id_tg_cyrl = 381
, Id_tg_latn = 382
, Id_th = 383
, Id_ti = 384
, Id_tk = 385
, Id_tl = 386
, Id_tly = 387
, Id_tn = 388
, Id_to = 389
, Id_tokipona = 390
, Id_tp = 391
, Id_tpi = 392
, Id_tr = 393
, Id_tru = 394
, Id_ts = 395
, Id_tt = 396
, Id_tt_cyrl = 397
, Id_tt_latn = 398
, Id_ttt = 399
, Id_tum = 400
, Id_tw = 401
, Id_ty = 402
, Id_tyv = 403
, Id_tzm = 404
, Id_ua = 405
, Id_udm = 406
, Id_ug = 407
, Id_ug_arab = 408
, Id_ug_latn = 409
, Id_uk = 410
, Id_ur = 411
, Id_uz = 412
, Id_ve = 413
, Id_vec = 414
, Id_vep = 415
, Id_vi = 416
, Id_vls = 417
, Id_vmf = 418
, Id_vo = 419
, Id_vot = 420
, Id_vro = 421
, Id_wa = 422
, Id_war = 423
, Id_wo = 424
, Id_wuu = 425
, Id_xal = 426
, Id_xh = 427
, Id_xmf = 428
, Id_yi = 429
, Id_yo = 430
, Id_yue = 431
, Id_za = 432
, Id_zea = 433
, Id_zh = 434
, Id_zh_classical = 435
, Id_zh_cn = 436
, Id_zh_hans = 437
, Id_zh_hant = 438
, Id_zh_hk = 439
, Id_zh_min_nan = 440
, Id_zh_mo = 441
, Id_zh_my = 442
, Id_zh_sg = 443
, Id_zh_tw = 444
, Id_zh_yue = 445
, Id_zu = 446
	;
	public static final int Id__max = 447;
	public static Hash_adp_bry Regy() {
		if (stub_hash == null) {	// NOTE: any parenthetical String below will have an "unseen" character of "\xE2\x80\xAA" at the begining and "\xE2\x80\xAC" at the end. They are responsible for parentheses-orientation in RTL stub_ary.
stub_hash = Hash_adp_bry.ci_a7();	// ASCII:lang_code; NOTE: must be ci; EX: {{#languages:FR}}
Regy_add(stub_hash, Id_en, "en", "English");
Regy_add(stub_hash, Id_aa, "aa", "Qafár af");
Regy_add(stub_hash, Id_ab, "ab", "Аҧсуа");
Regy_add(stub_hash, Id_ace, "ace", "Acèh");
Regy_add(stub_hash, Id_ady, "ady", "Adyghe");
Regy_add(stub_hash, Id_ady_cyrl, "ady-cyrl", "West Circassian (Cyrillic)");
Regy_add(stub_hash, Id_aeb, "aeb", "زَوُن");
Regy_add(stub_hash, Id_aeb_arab, "aeb-arab", "زَوُن");
Regy_add(stub_hash, Id_aeb_latn, "aeb-latn", "زَوُن");
Regy_add(stub_hash, Id_af, "af", "Afrikaans");
Regy_add(stub_hash, Id_ak, "ak", "Akan");
Regy_add(stub_hash, Id_akz, "akz", "Alibamu");
Regy_add(stub_hash, Id_aln, "aln", "Gegë");
Regy_add(stub_hash, Id_als, "als", "Alemannisch");
Regy_add(stub_hash, Id_am, "am", "አማርኛ");
Regy_add(stub_hash, Id_an, "an", "Aragonés");
Regy_add(stub_hash, Id_ang, "ang", "Ænglisc");
Regy_add(stub_hash, Id_anp, "anp", "अङ्गिका");
Regy_add(stub_hash, Id_ar, "ar", "العربية");
Regy_add(stub_hash, Id_arc, "arc", "ܐܪܡܝܐ");
Regy_add(stub_hash, Id_arn, "arn", "Mapudungun");
Regy_add(stub_hash, Id_aro, "aro", "Araona");
Regy_add(stub_hash, Id_arq, "arq", "Algerian Arabic");
Regy_add(stub_hash, Id_ary, "ary", "Maġribi");
Regy_add(stub_hash, Id_arz, "arz", "مصرى");
Regy_add(stub_hash, Id_as, "as", "অসমীয়া");
Regy_add(stub_hash, Id_ase, "ase", "American Sign Language");
Regy_add(stub_hash, Id_ast, "ast", "Asturianu");
Regy_add(stub_hash, Id_av, "av", "Авар");
Regy_add(stub_hash, Id_avk, "avk", "Kotava");
Regy_add(stub_hash, Id_awa, "awa", "Awadhi");
Regy_add(stub_hash, Id_ay, "ay", "Aymar aru");
Regy_add(stub_hash, Id_az, "az", "Azərbaycanca");
Regy_add(stub_hash, Id_azb, "azb", "South Azerbaijani");
Regy_add(stub_hash, Id_ba, "ba", "Башҡортса");
Regy_add(stub_hash, Id_ban, "ban", "ᬩᬲᬩᬮᬶ");
Regy_add(stub_hash, Id_bar, "bar", "Boarisch");
Regy_add(stub_hash, Id_bat_smg, "bat-smg", "Žemaitėška");
Regy_add(stub_hash, Id_bbc, "bbc", "Batak Toba");
Regy_add(stub_hash, Id_bbc_latn, "bbc-latn", "Batak Toba (Latin)");
Regy_add(stub_hash, Id_bcc, "bcc", "بلوچی مکرانی");
Regy_add(stub_hash, Id_bcl, "bcl", "Bikol Central");
Regy_add(stub_hash, Id_be, "be", "Беларуская");
Regy_add(stub_hash, Id_be_tarask, "be-tarask", "‪Беларуская (тарашкевіца)‬");
Regy_add(stub_hash, Id_be_x_old, "be-x-old", "‪Беларуская (тарашкевіца)‬");
Regy_add(stub_hash, Id_bew, "bew", "Betawi");
Regy_add(stub_hash, Id_bg, "bg", "Български");
Regy_add(stub_hash, Id_bgn, "bgn", "Balochi");
Regy_add(stub_hash, Id_bh, "bh", "भोजपुरी");
Regy_add(stub_hash, Id_bho, "bho", "भोजपुरी");
Regy_add(stub_hash, Id_bi, "bi", "Bislama");
Regy_add(stub_hash, Id_bjn, "bjn", "Bahasa Banjar");
Regy_add(stub_hash, Id_bm, "bm", "Bamanankan");
Regy_add(stub_hash, Id_bn, "bn", "বাংলা");
Regy_add(stub_hash, Id_bo, "bo", "བོད་ཡིག");
Regy_add(stub_hash, Id_bpy, "bpy", "ইমার ঠার/বিষ্ণুপ্রিয়া মণিপুরী");
Regy_add(stub_hash, Id_bqi, "bqi", "بختياري");
Regy_add(stub_hash, Id_br, "br", "Brezhoneg");
Regy_add(stub_hash, Id_brh, "brh", "Bráhuí");
Regy_add(stub_hash, Id_bs, "bs", "Bosanski");
Regy_add(stub_hash, Id_bto, "bto", "Rinconada Bikol");
Regy_add(stub_hash, Id_bug, "bug", "ᨅᨔ ᨕᨘᨁᨗ");
Regy_add(stub_hash, Id_bxr, "bxr", "Буряад");
Regy_add(stub_hash, Id_ca, "ca", "Català");
Regy_add(stub_hash, Id_cbk_zam, "cbk-zam", "Chavacano de Zamboanga");
Regy_add(stub_hash, Id_cdo, "cdo", "Mìng-dĕ̤ng-ngṳ̄");
Regy_add(stub_hash, Id_ce, "ce", "Нохчийн");
Regy_add(stub_hash, Id_ceb, "ceb", "Cebuano");
Regy_add(stub_hash, Id_ch, "ch", "Chamoru");
Regy_add(stub_hash, Id_chm, "chm", "Mari");
Regy_add(stub_hash, Id_cho, "cho", "Choctaw");
Regy_add(stub_hash, Id_chr, "chr", "ᏣᎳᎩ");
Regy_add(stub_hash, Id_chy, "chy", "Tsetsêhestâhese");
Regy_add(stub_hash, Id_ckb, "ckb", "کوردی");
Regy_add(stub_hash, Id_co, "co", "Corsu");
Regy_add(stub_hash, Id_cps, "cps", "Capiceño");
Regy_add(stub_hash, Id_cr, "cr", "Nēhiyawēwin / ᓀᐦᐃᔭᐍᐏᐣ");
Regy_add(stub_hash, Id_crh, "crh", "Qırımtatarca");
Regy_add(stub_hash, Id_crh_cyrl, "crh-cyrl", "‪Къырымтатарджа (Кирилл)‬");
Regy_add(stub_hash, Id_crh_latn, "crh-latn", "‪Qırımtatarca (Latin)‬");
Regy_add(stub_hash, Id_cs, "cs", "Česky");
Regy_add(stub_hash, Id_csb, "csb", "Kaszëbsczi");
Regy_add(stub_hash, Id_cu, "cu", "Словѣ́ньскъ / ⰔⰎⰑⰂⰡⰐⰠⰔⰍⰟ");
Regy_add(stub_hash, Id_cv, "cv", "Чӑвашла");
Regy_add(stub_hash, Id_cy, "cy", "Cymraeg");
Regy_add(stub_hash, Id_da, "da", "Dansk");
Regy_add(stub_hash, Id_de, "de", "Deutsch");
Regy_add(stub_hash, Id_de_at, "de-at", "Österreichisches Deutsch");
Regy_add(stub_hash, Id_de_ch, "de-ch", "Schweizer Hochdeutsch");
Regy_add(stub_hash, Id_de_formal, "de-formal", "‪Deutsch (Sie-Form)‬");
Regy_add(stub_hash, Id_diq, "diq", "Zazaki");
Regy_add(stub_hash, Id_dsb, "dsb", "Dolnoserbski");
Regy_add(stub_hash, Id_dtp, "dtp", "Dusun Bundu-liwan");
Regy_add(stub_hash, Id_dty, "dty", "Dotyali");
Regy_add(stub_hash, Id_dv, "dv", "ދިވެހިބަސް");
Regy_add(stub_hash, Id_dz, "dz", "ཇོང་ཁ");
Regy_add(stub_hash, Id_ee, "ee", "Eʋegbe");
Regy_add(stub_hash, Id_egl, "egl", "Emiliàn");
Regy_add(stub_hash, Id_el, "el", "Ελληνικά");
Regy_add(stub_hash, Id_eml, "eml", "Emiliàn e rumagnòl");
Regy_add(stub_hash, Id_en_ca, "en-ca", "Canadian English");
Regy_add(stub_hash, Id_en_gb, "en-gb", "British English");
Regy_add(stub_hash, Id_en_rtl, "en-rtl", "English rtl");
Regy_add(stub_hash, Id_enrtl, "enrtl", "English (right to left)");
Regy_add(stub_hash, Id_eo, "eo", "Esperanto");
Regy_add(stub_hash, Id_es, "es", "Español");
Regy_add(stub_hash, Id_es_formal, "es-formal", "Spanish (formal)");
Regy_add(stub_hash, Id_esu, "esu", "Yuk'ip");
Regy_add(stub_hash, Id_et, "et", "Eesti");
Regy_add(stub_hash, Id_eu, "eu", "Euskara");
Regy_add(stub_hash, Id_ext, "ext", "Estremeñu");
Regy_add(stub_hash, Id_fa, "fa", "فارسی");
Regy_add(stub_hash, Id_ff, "ff", "Fulfulde");
Regy_add(stub_hash, Id_fi, "fi", "Suomi");
Regy_add(stub_hash, Id_fit, "fit", "meänkieli");
Regy_add(stub_hash, Id_fiu_vro, "fiu-vro", "Võro");
Regy_add(stub_hash, Id_fj, "fj", "Na Vosa Vakaviti");
Regy_add(stub_hash, Id_fo, "fo", "Føroyskt");
Regy_add(stub_hash, Id_fr, "fr", "Français");
Regy_add(stub_hash, Id_frc, "frc", "Français cadien");
Regy_add(stub_hash, Id_frp, "frp", "Arpetan");
Regy_add(stub_hash, Id_frr, "frr", "Nordfriisk");
Regy_add(stub_hash, Id_fur, "fur", "Furlan");
Regy_add(stub_hash, Id_fy, "fy", "Frysk");
Regy_add(stub_hash, Id_ga, "ga", "Gaeilge");
Regy_add(stub_hash, Id_gag, "gag", "Gagauz");
Regy_add(stub_hash, Id_gan, "gan", "贛語");
Regy_add(stub_hash, Id_gan_hans, "gan-hans", "‪赣语(简体)‬");
Regy_add(stub_hash, Id_gan_hant, "gan-hant", "‪贛語(繁體)‬");
Regy_add(stub_hash, Id_gd, "gd", "Gàidhlig");
Regy_add(stub_hash, Id_gl, "gl", "Galego");
Regy_add(stub_hash, Id_glk, "glk", "گیلکی");
Regy_add(stub_hash, Id_gn, "gn", "Avañe'ẽ");
Regy_add(stub_hash, Id_gom, "gom", "कोंकणी");
Regy_add(stub_hash, Id_gom_deva, "gom-deva", "Konkani");
Regy_add(stub_hash, Id_gom_latn, "gom-latn", "कोंकणी (Latin)");
Regy_add(stub_hash, Id_gor, "gor", "Gor");
Regy_add(stub_hash, Id_got, "got", "𐌲𐌿𐍄𐌹𐍃𐌺");
Regy_add(stub_hash, Id_grc, "grc", "Ἀρχαία ἑλληνικὴ");
Regy_add(stub_hash, Id_gsw, "gsw", "Alemannisch");
Regy_add(stub_hash, Id_gu, "gu", "ગુજરાતી");
Regy_add(stub_hash, Id_guc, "guc", "Wayuu");
Regy_add(stub_hash, Id_gv, "gv", "Gaelg");
Regy_add(stub_hash, Id_ha, "ha", "هَوُسَ");
Regy_add(stub_hash, Id_hak, "hak", "Hak-kâ-fa");
Regy_add(stub_hash, Id_haw, "haw", "Hawai`i");
Regy_add(stub_hash, Id_he, "he", "עברית");
Regy_add(stub_hash, Id_hi, "hi", "हिन्दी");
Regy_add(stub_hash, Id_hif, "hif", "Fiji Hindi");
Regy_add(stub_hash, Id_hif_latn, "hif-latn", "Fiji Hindi");
Regy_add(stub_hash, Id_hil, "hil", "Ilonggo");
Regy_add(stub_hash, Id_ho, "ho", "Hiri Motu");
Regy_add(stub_hash, Id_hr, "hr", "Hrvatski");
Regy_add(stub_hash, Id_hrx, "hrx", "Hunsriker");
Regy_add(stub_hash, Id_hsb, "hsb", "Hornjoserbsce");
Regy_add(stub_hash, Id_hsn, "hsn", "Xiang");
Regy_add(stub_hash, Id_ht, "ht", "Kreyòl ayisyen");
Regy_add(stub_hash, Id_hu, "hu", "Magyar");
Regy_add(stub_hash, Id_hu_formal, "hu-formal", "Magyar (formal)");
Regy_add(stub_hash, Id_hy, "hy", "Հայերեն");
Regy_add(stub_hash, Id_hz, "hz", "Otsiherero");
Regy_add(stub_hash, Id_ia, "ia", "Interlingua");
Regy_add(stub_hash, Id_id, "id", "Bahasa Indonesia");
Regy_add(stub_hash, Id_ie, "ie", "Interlingue");
Regy_add(stub_hash, Id_ig, "ig", "Igbo");
Regy_add(stub_hash, Id_ii, "ii", "ꆇꉙ");
Regy_add(stub_hash, Id_ik, "ik", "Iñupiak");
Regy_add(stub_hash, Id_ike_cans, "ike-cans", "ᐃᓄᒃᑎᑐᑦ");
Regy_add(stub_hash, Id_ike_latn, "ike-latn", "inuktitut");
Regy_add(stub_hash, Id_ilo, "ilo", "Ilokano");
Regy_add(stub_hash, Id_inh, "inh", "ГІалгІай Ğalğaj");
Regy_add(stub_hash, Id_io, "io", "Ido");
Regy_add(stub_hash, Id_is, "is", "Íslenska");
Regy_add(stub_hash, Id_it, "it", "Italiano");
Regy_add(stub_hash, Id_iu, "iu", "ᐃᓄᒃᑎᑐᑦ/inuktitut");
Regy_add(stub_hash, Id_izh, "izh", "Ingrian");
Regy_add(stub_hash, Id_ja, "ja", "日本語");
Regy_add(stub_hash, Id_jam, "jam", "Patois");
Regy_add(stub_hash, Id_jbo, "jbo", "Lojban");
Regy_add(stub_hash, Id_jut, "jut", "Jysk");
Regy_add(stub_hash, Id_jv, "jv", "Basa Jawa");
Regy_add(stub_hash, Id_ka, "ka", "ქართული");
Regy_add(stub_hash, Id_kaa, "kaa", "Qaraqalpaqsha");
Regy_add(stub_hash, Id_kab, "kab", "Taqbaylit");
Regy_add(stub_hash, Id_kbd, "kbd", "Къэбэрдеибзэ / Qabardjajəbza");
Regy_add(stub_hash, Id_kbd_cyrl, "kbd-cyrl", "къэбэрдеибзэ");
Regy_add(stub_hash, Id_kg, "kg", "Kongo");
Regy_add(stub_hash, Id_khw, "khw", "کھوار");
Regy_add(stub_hash, Id_ki, "ki", "Gĩkũyũ");
Regy_add(stub_hash, Id_kiu, "kiu", "Kırmancki");
Regy_add(stub_hash, Id_kj, "kj", "Kwanyama");
Regy_add(stub_hash, Id_kk, "kk", "Қазақша");
Regy_add(stub_hash, Id_kk_arab, "kk-arab", "‫قازاقشا (تٴوتە)‬");
Regy_add(stub_hash, Id_kk_cn, "kk-cn", "‫قازاقشا (جۇنگو)‬");
Regy_add(stub_hash, Id_kk_cyrl, "kk-cyrl", "‪Қазақша (кирил)‬");
Regy_add(stub_hash, Id_kk_kz, "kk-kz", "‪Қазақша (Қазақстан)‬");
Regy_add(stub_hash, Id_kk_latn, "kk-latn", "‪Qazaqşa (latın)‬");
Regy_add(stub_hash, Id_kk_tr, "kk-tr", "‪Qazaqşa (Türkïya)‬");
Regy_add(stub_hash, Id_kl, "kl", "Kalaallisut");
Regy_add(stub_hash, Id_km, "km", "ភាសាខ្មែរ");
Regy_add(stub_hash, Id_kn, "kn", "ಕನ್ನಡ");
Regy_add(stub_hash, Id_ko, "ko", "한국어");
Regy_add(stub_hash, Id_ko_kp, "ko-kp", "한국어 (조선)");
Regy_add(stub_hash, Id_koi, "koi", "Перем Коми");
Regy_add(stub_hash, Id_kok, "kok", "");
Regy_add(stub_hash, Id_kr, "kr", "Kanuri");
Regy_add(stub_hash, Id_krc, "krc", "Къарачай-Малкъар");
Regy_add(stub_hash, Id_kri, "kri", "Krio");
Regy_add(stub_hash, Id_krj, "krj", "Kinaray-a");
Regy_add(stub_hash, Id_krl, "krl", "Karelian");
Regy_add(stub_hash, Id_ks, "ks", "कश्मीरी - (كشميري)");
Regy_add(stub_hash, Id_ks_arab, "ks-arab", "کٲشُر");
Regy_add(stub_hash, Id_ks_deva, "ks-deva", "कॉशुर");
Regy_add(stub_hash, Id_ksh, "ksh", "Ripoarisch");
Regy_add(stub_hash, Id_ku, "ku", "Kurdî");
Regy_add(stub_hash, Id_ku_arab, "ku-arab", "‫كوردي (عەرەبی)‬");
Regy_add(stub_hash, Id_ku_latn, "ku-latn", "‪Kurdî (latînî)‬");
Regy_add(stub_hash, Id_kv, "kv", "Коми");
Regy_add(stub_hash, Id_kw, "kw", "Kernowek");
Regy_add(stub_hash, Id_ky, "ky", "Кыргызча");
Regy_add(stub_hash, Id_la, "la", "Latina");
Regy_add(stub_hash, Id_lad, "lad", "Ladino");
Regy_add(stub_hash, Id_lb, "lb", "Lëtzebuergesch");
Regy_add(stub_hash, Id_lbe, "lbe", "Лакку");
Regy_add(stub_hash, Id_lez, "lez", "Лезги");
Regy_add(stub_hash, Id_lfn, "lfn", "Lingua Franca Nova");
Regy_add(stub_hash, Id_lg, "lg", "Luganda");
Regy_add(stub_hash, Id_li, "li", "Limburgs");
Regy_add(stub_hash, Id_lij, "lij", "Líguru");
Regy_add(stub_hash, Id_liv, "liv", "Līvõ kēļ");
Regy_add(stub_hash, Id_lki, "lki", "Laki");
Regy_add(stub_hash, Id_lmo, "lmo", "Lumbaart");
Regy_add(stub_hash, Id_ln, "ln", "Lingála");
Regy_add(stub_hash, Id_lo, "lo", "ລາວ");
Regy_add(stub_hash, Id_loz, "loz", "Silozi");
Regy_add(stub_hash, Id_lrc, "lrc", "لوری");
Regy_add(stub_hash, Id_lt, "lt", "Lietuvių");
Regy_add(stub_hash, Id_ltg, "ltg", "Latgaļu");
Regy_add(stub_hash, Id_lus, "lus", "Mizo ţawng");
Regy_add(stub_hash, Id_luz, "luz", "Luri");
Regy_add(stub_hash, Id_lv, "lv", "Latviešu");
Regy_add(stub_hash, Id_lzh, "lzh", "文言");
Regy_add(stub_hash, Id_lzz, "lzz", "Lazuri");
Regy_add(stub_hash, Id_mai, "mai", "मैथिली");
Regy_add(stub_hash, Id_map_bms, "map-bms", "Basa Banyumasan");
Regy_add(stub_hash, Id_mdf, "mdf", "Мокшень");
Regy_add(stub_hash, Id_mg, "mg", "Malagasy");
Regy_add(stub_hash, Id_mh, "mh", "Ebon");
Regy_add(stub_hash, Id_mhr, "mhr", "Олык Марий");
Regy_add(stub_hash, Id_mi, "mi", "Māori");
Regy_add(stub_hash, Id_mic, "mic", "Mi'kmaq");
Regy_add(stub_hash, Id_min, "min", "Baso Minangkabau");
Regy_add(stub_hash, Id_mk, "mk", "Македонски");
Regy_add(stub_hash, Id_ml, "ml", "മലയാളം");
Regy_add(stub_hash, Id_mn, "mn", "Монгол");
Regy_add(stub_hash, Id_mnc, "mnc", "Manchu");
Regy_add(stub_hash, Id_mo, "mo", "Молдовеняскэ");
Regy_add(stub_hash, Id_mr, "mr", "मराठी");
Regy_add(stub_hash, Id_mrj, "mrj", "Кырык мары");
Regy_add(stub_hash, Id_ms, "ms", "Bahasa Melayu");
Regy_add(stub_hash, Id_mt, "mt", "Malti");
Regy_add(stub_hash, Id_mui, "mui", "Musi");
Regy_add(stub_hash, Id_mus, "mus", "Mvskoke");
Regy_add(stub_hash, Id_mwl, "mwl", "Mirandés");
Regy_add(stub_hash, Id_mwv, "mwv", "Behase Mentawei");
Regy_add(stub_hash, Id_my, "my", "Burmese");
Regy_add(stub_hash, Id_myv, "myv", "Эрзянь");
Regy_add(stub_hash, Id_mzn, "mzn", "مازِرونی");
Regy_add(stub_hash, Id_na, "na", "Dorerin Naoero");
Regy_add(stub_hash, Id_nah, "nah", "Nāhuatl");
Regy_add(stub_hash, Id_nan, "nan", "Bân-lâm-gú");
Regy_add(stub_hash, Id_nap, "nap", "Nnapulitano");
Regy_add(stub_hash, Id_nb, "nb", "‪Norsk (bokmål)‬");
Regy_add(stub_hash, Id_nds, "nds", "Plattdüütsch");
Regy_add(stub_hash, Id_nds_nl, "nds-nl", "Nedersaksisch");
Regy_add(stub_hash, Id_ne, "ne", "नेपाली");
Regy_add(stub_hash, Id_new, "new", "नेपाल भाषा");
Regy_add(stub_hash, Id_ng, "ng", "Oshiwambo");
Regy_add(stub_hash, Id_niu, "niu", "Niuē");
Regy_add(stub_hash, Id_nl, "nl", "Nederlands");
Regy_add(stub_hash, Id_nl_informal, "nl-informal", "‪Nederlands (informeel)‬");
Regy_add(stub_hash, Id_nn, "nn", "‪Norsk (nynorsk)‬");
Regy_add(stub_hash, Id_no, "no", "‪Norsk (bokmål)‬");
Regy_add(stub_hash, Id_nov, "nov", "Novial");
Regy_add(stub_hash, Id_nrm, "nrm", "Nouormand");
Regy_add(stub_hash, Id_nso, "nso", "Sesotho sa Leboa");
Regy_add(stub_hash, Id_nv, "nv", "Diné bizaad");
Regy_add(stub_hash, Id_ny, "ny", "Chi-Chewa");
Regy_add(stub_hash, Id_oc, "oc", "Occitan");
Regy_add(stub_hash, Id_olo, "olo", "Olo");
Regy_add(stub_hash, Id_om, "om", "Oromoo");
Regy_add(stub_hash, Id_or, "or", "ଓଡ଼ିଆ");
Regy_add(stub_hash, Id_os, "os", "Иронау");
Regy_add(stub_hash, Id_pa, "pa", "ਪੰਜਾਬੀ");
Regy_add(stub_hash, Id_pag, "pag", "Pangasinan");
Regy_add(stub_hash, Id_pam, "pam", "Kapampangan");
Regy_add(stub_hash, Id_pap, "pap", "Papiamentu");
Regy_add(stub_hash, Id_pbb, "pbb", "Páez");
Regy_add(stub_hash, Id_pcd, "pcd", "Picard");
Regy_add(stub_hash, Id_pdc, "pdc", "Deitsch");
Regy_add(stub_hash, Id_pdt, "pdt", "Plautdietsch");
Regy_add(stub_hash, Id_pfl, "pfl", "Pälzisch");
Regy_add(stub_hash, Id_pi, "pi", "पािऴ");
Regy_add(stub_hash, Id_pih, "pih", "Norfuk / Pitkern");
Regy_add(stub_hash, Id_pl, "pl", "Polski");
Regy_add(stub_hash, Id_pms, "pms", "Piemontèis");
Regy_add(stub_hash, Id_pnb, "pnb", "پنجابی");
Regy_add(stub_hash, Id_pnt, "pnt", "Ποντιακά");
Regy_add(stub_hash, Id_ppl, "ppl", "Pipil");
Regy_add(stub_hash, Id_prg, "prg", "Prūsiskan");
Regy_add(stub_hash, Id_ps, "ps", "پښتو");
Regy_add(stub_hash, Id_pt, "pt", "Português");
Regy_add(stub_hash, Id_pt_br, "pt-br", "Português do Brasil");
Regy_add(stub_hash, Id_qqq, "qqq", "MediaWiki sample");
Regy_add(stub_hash, Id_qu, "qu", "Runa Simi");
Regy_add(stub_hash, Id_qug, "qug", "Runa shimi");
Regy_add(stub_hash, Id_rap, "rap", "Rapa Nui");
Regy_add(stub_hash, Id_rgn, "rgn", "Rumagnôl");
Regy_add(stub_hash, Id_rif, "rif", "Tarifit");
Regy_add(stub_hash, Id_rm, "rm", "Rumantsch");
Regy_add(stub_hash, Id_rmf, "rmf", "Finnish Kalo");
Regy_add(stub_hash, Id_rmy, "rmy", "Romani");
Regy_add(stub_hash, Id_rn, "rn", "Kirundi");
Regy_add(stub_hash, Id_ro, "ro", "Română");
Regy_add(stub_hash, Id_roa_rup, "roa-rup", "Armãneashce");
Regy_add(stub_hash, Id_roa_tara, "roa-tara", "Tarandíne");
Regy_add(stub_hash, Id_ru, "ru", "Русский");
Regy_add(stub_hash, Id_rue, "rue", "Русиньскый");
Regy_add(stub_hash, Id_rup, "rup", "Armãneașce");
Regy_add(stub_hash, Id_ruq, "ruq", "Vlăheşte");
Regy_add(stub_hash, Id_ruq_cyrl, "ruq-cyrl", "Влахесте");
Regy_add(stub_hash, Id_ruq_latn, "ruq-latn", "Vlăheşte");
Regy_add(stub_hash, Id_rw, "rw", "Kinyarwanda");
Regy_add(stub_hash, Id_ryu, "ryu", "Okinawan");
Regy_add(stub_hash, Id_sa, "sa", "संस्कृत");
Regy_add(stub_hash, Id_sah, "sah", "Саха тыла");
Regy_add(stub_hash, Id_sat, "sat", "Santali");
Regy_add(stub_hash, Id_saz, "saz", "Saurashtra");
Regy_add(stub_hash, Id_sc, "sc", "Sardu");
Regy_add(stub_hash, Id_scn, "scn", "Sicilianu");
Regy_add(stub_hash, Id_sco, "sco", "Scots");
Regy_add(stub_hash, Id_sd, "sd", "سنڌي");
Regy_add(stub_hash, Id_sdc, "sdc", "Sassaresu");
Regy_add(stub_hash, Id_sdh, "sdh", "Southern Kurdish");
Regy_add(stub_hash, Id_se, "se", "Sámegiella");
Regy_add(stub_hash, Id_sei, "sei", "Cmique Itom");
Regy_add(stub_hash, Id_ses, "ses", "Songhay");
Regy_add(stub_hash, Id_sg, "sg", "Sängö");
Regy_add(stub_hash, Id_sgs, "sgs", "Žemaitėška");
Regy_add(stub_hash, Id_sh, "sh", "Srpskohrvatski / Српскохрватски");
Regy_add(stub_hash, Id_shi, "shi", "Tašlḥiyt");
Regy_add(stub_hash, Id_shn, "shn", "Shan");
Regy_add(stub_hash, Id_si, "si", "Sinhalese");
Regy_add(stub_hash, Id_simple, "simple", "Simple English");
Regy_add(stub_hash, Id_sk, "sk", "Slovenčina");
Regy_add(stub_hash, Id_sl, "sl", "Slovenščina");
Regy_add(stub_hash, Id_sli, "sli", "Schläsch");
Regy_add(stub_hash, Id_sly, "sly", "Selayar");
Regy_add(stub_hash, Id_sm, "sm", "Gagana Samoa");
Regy_add(stub_hash, Id_sma, "sma", "Åarjelsaemien");
Regy_add(stub_hash, Id_sn, "sn", "chiShona");
Regy_add(stub_hash, Id_so, "so", "Soomaaliga");
Regy_add(stub_hash, Id_sq, "sq", "Shqip");
Regy_add(stub_hash, Id_sr, "sr", "Српски / Srpski");
Regy_add(stub_hash, Id_sr_ec, "sr-ec", "‪Српски (ћирилица)‬");
Regy_add(stub_hash, Id_sr_el, "sr-el", "‪Srpski (latinica)‬");
Regy_add(stub_hash, Id_srn, "srn", "Sranantongo");
Regy_add(stub_hash, Id_ss, "ss", "SiSwati");
Regy_add(stub_hash, Id_st, "st", "Sesotho");
Regy_add(stub_hash, Id_stq, "stq", "Seeltersk");
Regy_add(stub_hash, Id_su, "su", "Basa Sunda");
Regy_add(stub_hash, Id_sv, "sv", "Svenska");
Regy_add(stub_hash, Id_sw, "sw", "Kiswahili");
Regy_add(stub_hash, Id_sxu, "sxu", "Saxon, Upper");
Regy_add(stub_hash, Id_szl, "szl", "Ślůnski");
Regy_add(stub_hash, Id_ta, "ta", "தமிழ்");
Regy_add(stub_hash, Id_tcy, "tcy", "ತುಳು");
Regy_add(stub_hash, Id_te, "te", "తెలుగు");
Regy_add(stub_hash, Id_test, "test", "MediaWiki test");
Regy_add(stub_hash, Id_tet, "tet", "Tetun");
Regy_add(stub_hash, Id_tg, "tg", "Тоҷикӣ");
Regy_add(stub_hash, Id_tg_cyrl, "tg-cyrl", "Тоҷикӣ");
Regy_add(stub_hash, Id_tg_latn, "tg-latn", "tojikī");
Regy_add(stub_hash, Id_th, "th", "ไทย");
Regy_add(stub_hash, Id_ti, "ti", "ትግርኛ");
Regy_add(stub_hash, Id_tk, "tk", "Türkmençe");
Regy_add(stub_hash, Id_tl, "tl", "Tagalog");
Regy_add(stub_hash, Id_tly, "tly", "толышә зывон");
Regy_add(stub_hash, Id_tn, "tn", "Setswana");
Regy_add(stub_hash, Id_to, "to", "lea faka-Tonga");
Regy_add(stub_hash, Id_tokipona, "tokipona", "Toki Pona");
Regy_add(stub_hash, Id_tp, "tp", "Toki Pona (deprecated:tokipona)");
Regy_add(stub_hash, Id_tpi, "tpi", "Tok Pisin");
Regy_add(stub_hash, Id_tr, "tr", "Türkçe");
Regy_add(stub_hash, Id_tru, "tru", "Ṫuroyo");
Regy_add(stub_hash, Id_ts, "ts", "Xitsonga");
Regy_add(stub_hash, Id_tt, "tt", "Татарча/Tatarça");
Regy_add(stub_hash, Id_tt_cyrl, "tt-cyrl", "Татарча");
Regy_add(stub_hash, Id_tt_latn, "tt-latn", "Tatarça");
Regy_add(stub_hash, Id_ttt, "ttt", "Tat, Muslim");
Regy_add(stub_hash, Id_tum, "tum", "chiTumbuka");
Regy_add(stub_hash, Id_tw, "tw", "Twi");
Regy_add(stub_hash, Id_ty, "ty", "Reo Mā`ohi");
Regy_add(stub_hash, Id_tyv, "tyv", "Тыва дыл");
Regy_add(stub_hash, Id_tzm, "tzm", "ⵜⴰⵎⴰⵣⵉⵖⵜ");
Regy_add(stub_hash, Id_ua, "ua", "Ukrainian");
Regy_add(stub_hash, Id_udm, "udm", "Удмурт");
Regy_add(stub_hash, Id_ug, "ug", "ئۇيغۇرچە / Uyghurche‎");
Regy_add(stub_hash, Id_ug_arab, "ug-arab", "ئۇيغۇرچە");
Regy_add(stub_hash, Id_ug_latn, "ug-latn", "Uyghurche‎");
Regy_add(stub_hash, Id_uk, "uk", "Українська");
Regy_add(stub_hash, Id_ur, "ur", "اردو");
Regy_add(stub_hash, Id_uz, "uz", "O'zbek");
Regy_add(stub_hash, Id_ve, "ve", "Tshivenda");
Regy_add(stub_hash, Id_vec, "vec", "Vèneto");
Regy_add(stub_hash, Id_vep, "vep", "Vepsan kel'");
Regy_add(stub_hash, Id_vi, "vi", "Tiếng Việt");
Regy_add(stub_hash, Id_vls, "vls", "West-Vlams");
Regy_add(stub_hash, Id_vmf, "vmf", "Mainfränkisch");
Regy_add(stub_hash, Id_vo, "vo", "Volapük");
Regy_add(stub_hash, Id_vot, "vot", "Vaďďa");
Regy_add(stub_hash, Id_vro, "vro", "Võro");
Regy_add(stub_hash, Id_wa, "wa", "Walon");
Regy_add(stub_hash, Id_war, "war", "Winaray");
Regy_add(stub_hash, Id_wo, "wo", "Wolof");
Regy_add(stub_hash, Id_wuu, "wuu", "吴语");
Regy_add(stub_hash, Id_xal, "xal", "Хальмг");
Regy_add(stub_hash, Id_xh, "xh", "isiXhosa");
Regy_add(stub_hash, Id_xmf, "xmf", "მარგალური");
Regy_add(stub_hash, Id_yi, "yi", "ייִדיש");
Regy_add(stub_hash, Id_yo, "yo", "Yorùbá");
Regy_add(stub_hash, Id_yue, "yue", "粵語");
Regy_add(stub_hash, Id_za, "za", "Vahcuengh");
Regy_add(stub_hash, Id_zea, "zea", "Zeêuws");
Regy_add(stub_hash, Id_zh, "zh", "中文");
Regy_add(stub_hash, Id_zh_classical, "zh-classical", "文言");
Regy_add(stub_hash, Id_zh_cn, "zh-cn", "‪中文(中国大陆)‬");
Regy_add(stub_hash, Id_zh_hans, "zh-hans", "‪中文(简体)‬");
Regy_add(stub_hash, Id_zh_hant, "zh-hant", "‪中文(繁體)‬");
Regy_add(stub_hash, Id_zh_hk, "zh-hk", "‪中文(香港)‬");
Regy_add(stub_hash, Id_zh_min_nan, "zh-min-nan", "Bân-lâm-gú");
Regy_add(stub_hash, Id_zh_mo, "zh-mo", "‪中文(澳門)‬");
Regy_add(stub_hash, Id_zh_my, "zh-my", "‪中文(马来西亚)‬");
Regy_add(stub_hash, Id_zh_sg, "zh-sg", "‪中文(新加坡)‬");
Regy_add(stub_hash, Id_zh_tw, "zh-tw", "‪中文(台灣)‬");
Regy_add(stub_hash, Id_zh_yue, "zh-yue", "粵語");
Regy_add(stub_hash, Id_zu, "zu", "isiZulu");
		}
		return stub_hash;
	}
	private static Hash_adp_bry stub_hash; private static final    Xol_lang_stub[] stub_ary = new Xol_lang_stub[Id__max];
	public static Xol_lang_stub[] Ary() {return stub_ary;}
	private static void Regy_add(Hash_adp_bry stub_hash, int uid, String code_str, String canonical) {
		byte[] code = Bry_.new_a7(code_str);// ASCII:lang_code should always be ASCII
		Xol_lang_stub itm = new Xol_lang_stub(uid, code, Bry_.new_u8(canonical));
		stub_ary[uid] = itm;
		stub_hash.Add(code, itm);
	}
	public static boolean Exists(byte[] key) {return Get_by_key_or_null(key) != null;}	// Language.php!isSupportedLanguage
	public static Xol_lang_stub Get_by_id(int id) {if (stub_hash == null) Regy(); return stub_ary[id];}
	public static Xol_lang_stub Get_by_key_or_null(byte[] key) {return Get_by_key_or_null(key, 0, key.length);}
	public static Xol_lang_stub Get_by_key_or_null(byte[] key, int bgn, int end) {
		if (stub_hash == null) Regy();
		return (Xol_lang_stub)stub_hash.Get_by_mid(key, bgn, end);
	}
	public static Xol_lang_stub Get_by_key_or_en(byte[] key) {
		Xol_lang_stub rv = Get_by_key_or_null(key);
		return (rv == null) ? (Xol_lang_stub)stub_hash.Get_by_bry(Xol_lang_itm_.Key_en) : rv;
	}
	public static Xol_lang_stub Get_by_key_or_intl(byte[] key) {return Get_by_key_or_intl(key, 0, key.length);}
	public static Xol_lang_stub Get_by_key_or_intl(byte[] key, int bgn, int end) {
		Xol_lang_stub rv = Get_by_key_or_null(key, bgn, end);
		return rv == null ? Intl : rv;
	}
	public static final    Xol_lang_stub Intl = new Xol_lang_stub(Xol_lang_stub_.Id__intl, Bry_.Empty, Bry_.Empty);	// intended for international wikis like commons, wikidata, etc..
}
class Xol_sub_itm_comparer implements ComparerAble {
	public int compare(Object lhsObj, Object rhsObj) {
		Xol_lang_stub lhs = (Xol_lang_stub)lhsObj;
		Xol_lang_stub rhs = (Xol_lang_stub)rhsObj;
		return Bry_.Compare(lhs.Key(), rhs.Key());
	}
}
